<?php
$TITLE = "KITCUBE";
$MODULES = array("graph", "wiki");


$EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	),
	"tdms" => array(
	    'title' => "TDMS",
	    'handler' => "LABVIEW",
	    'type' => "tdms"
	)
);


$READER_DB_IMK = array(
	"kitcube" => array (
	    "title" => _("KIT Cube"),
	    "reader" => "IPEReader",
	    "driver" => "mysql",
	    "host" => "192.168.1.102",
	    "port" => 3306,
	    "user" => "cube",
	    "password" => "cube",
	    "database" => array("kitcube_actual"),
	    "charset" => "ISO8859-1",
	    "timeout" => 200000,	// us
//	    "ping" => true,		// host and port should be specified
//	    "disconnected" => true
	)
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_IMK, $READER_DB);
else $READER_DB = $READER_DB_IMK;


$OPTIONS["kitcube"] = array(
	    "groups" => array(
		"/^(.*)$/" => '${1}',
	    ),
	    "tables" => array(
		"/^(Data_[\w\d_]+)$/" => array(
//		"/^(Data_020_Ceilometer_chm|Data_025_JWD_dd|Data_099_System_log|Data_190_NF_dat)$/" => array(
		    'gid' => '${1}',
		    'title' => '${1}'
		)
	    ),
	    "columns" => array(
		"time" => "usec",
		"data" => "/(AVG|SUM|RATE|RES|INST|MOM|MIN|MAX|STD)$/"
	    ),
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
	    "time_module" => "USECTICKS",
//	    "date_limit" => "2000-01-01 00:00:00",		//GMT
//	    "date_limit" => array("2005-08-06 00:00:00","2005-08-08 00:00:00"),		//GMT
//	    "date_limit" => "2008-03-29 21:00:00",		//GMT
	    "time_format" => "U",
	    "min_resolution" => 10,
	    "ignore_subseconds" => true,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
	    "use_md5_postfix" => true,
/*	    "data_filters" => array(
		"BADVALUEFilter" => array (
		    "badvalue" => -9999
		),
	    ),*/
	    "axes_table" => array(
		"table" => "Axislist",
		"id" => "id",
		"properties" => array(
		    "axis_name" => "comment",
		    "axis_units" => "unit"
		)
	    ),
	    "item_table" => array(
		"table" => "Sensorlist",
		"id" => "name",
		//"gid" => "group",
		"properties" => array(
		    "name" => "comment",
		    "axis" => "axis"
		)
	    )
);

?>