<?php
$TITLE = "KITCUBE";
$MODULES = array("graph", "wiki");


$EXPORT_FORMATS = array (
	"csv" => array(
	    'title' => "CSV",
	),
	"xls" => array(
	    'title' => "Excel",
	    'handler' => "EXCEL",
	),
	"tdms" => array(
	    'title' => "TDMS",
	    'handler' => "LABVIEW",
	    'type' => "tdms"
	)
);


$READER_DB_KITCUBE = array(
	"kitcube" => array (
	    "title" => _("KIT Cube"),
	    "reader" => "IPEReader",
	    "driver" => "mysql",
	    "host" => "ipepdvsrv1",
	    "port" => 3306,
	    "user" => "adei",
	    "password" => "adei",
	    "database" => array("kitcube_active"),
	    "charset" => "ISO8859-1",
	    "timeout" => 200000,	// us
//	    "ping" => true,		// host and port should be specified
//	    "disconnected" => true
	)
);

if (is_array($READER_DB)) $READER_DB = array_merge($READER_DB_KITCUBE, $READER_DB);
else $READER_DB = $READER_DB_KITCUBE;


$OPTIONS["kitcube"] = array(
	    "groups" => array(
		"/^(.*)$/" => '${1}',
	    ),
	    "tables" => array(
		"/^(Data_[\w\d_]+)$/" => array(
//		"/^(Data_020_Ceilometer_chm|Data_025_JWD_dd|Data_099_System_log|Data_190_NF_dat)$/" => array(
		    'gid' => '${1}',
		    'title' => '${1}'
		)
	    ),
	    "columns" => array(
		"time" => "usec",
		"data" => "/^PARS.PARS1.(N|Z|L|P)/",
		"custom" => "/^PARS.PARS1.(V|O)/",
//		"data" => "/(AVG|SUM|RATE|RES|INST|MOM|MIN|MAX|STD|PPI|RHI|VER|VOL|PROF)$/"
	    ),
	    "sql_filters" => array(
	        "/^PARS.PARS1.(V|O)/" => array("UNCOMPRESS")
	    ),
	    "timesort" => 1,					// 0 - NATURAL, 1 - ASC, -1 - DESC, string whith request
	    "time_module" => "UNIXTicks",
	    "time_options" => array("ticks_per_second" => 1000000),
//	    "date_limit" => "2000-01-01 00:00:00",		//GMT
//	    "date_limit" => array("2005-08-06 00:00:00","2005-08-08 00:00:00"),		//GMT
//	    "date_limit" => "2008-03-29 21:00:00",		//GMT
	    "time_format" => "U",
	    "min_resolution" => 10,
	    "ignore_subseconds" => true,
	    "optimize_empty_cache" => true,
	    "use_cache_timewindow" => true,
//	    "use_cache_reader" => true,
            "custom_data_filters" => array(
                array(
                    "class" =>  "ITEMFilter",
                    "filter" => "BLOBDecoderItemFilter",
                    "item_mask" => "/^[^\d]/",
                    "format" => 'd*'
#                    "decoder" => function($value) { return unpack('d*', $value);  }
                )
            ),
	    "use_md5_postfix" => true,
	    "null_value" => "",
	    "axes_table" => array(
		"table" => "Axislist",
		"id" => "id",
		"properties" => array(
		    "axis_name" => "comment",
		    "axis_units" => "unit"
		)
	    ),
	    "item_table" => array(
		"table" => "Sensorlist",
		"id" => "name",
		//"gid" => "group",
		"properties" => array(
		    "name" => "comment",
		    "axis" => "axis"
		)
	    )
);

$OPTIONS["kitcube__kitcube_active__Data_030_PARS_dat"] = array(
            "data_extractors" => array(
                array(
                    "filter" => "SUMExtractor",
                    "output_mask" => "/sum/",
                    "item_mask" => array(
                        "key" => "column",
                        "items" => "/^PARS.PARS1.O.ND2.001.SUM$/",
                    )
                )
            ),
	    "data_filters" => array(
		array (
		    "class" => "ITEMFilter",
		    "filter" => "RANGEItemFilter",
		    "item_mask" => array(
		        array(
                            "key" => "item_dependency_column",
                            "items" => "/^PARS.PARS1.O.ND2.001.SUM$/",
		        ),
		        array(
                            "key" => "item_extractor",
                            "items" => "/^SUMExtractor$/",
		        )
		    ),
		    "min" => 100
		
		),
		array (
		    "class" => "ITEMFilter",
		    "filter" => "NULLItemFilter",
		    "item_mask" => array(
		        array(
                            "key" => "item_dependency_column",
                            "items" => "/^PARS.PARS1.O.ND2.001.SUM$/",
		        ),
		        array(
                            "key" => "item_extractor",
                            "items" => "/^SUMExtractor$/",
		        )
		    )
		
		)
	    )
);
